package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.ZdAssort;
import com.docus.server.infrastructure.dao.IZdAssortDao;
import com.docus.server.infrastructure.mapper.ZdAssortMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 病案分类 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-30
 */
@Repository
public class ZdAssortDaoImpl extends BaseDaoImpl<ZdAssortMapper, ZdAssort> implements IZdAssortDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public ZdAssort findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param zdAssort 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(ZdAssort zdAssort) {
        return super.save(zdAssort);
    }

    /**
     * 编辑
     *
     * @param zdAssort 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(ZdAssort zdAssort) {
        return super.updateById(zdAssort);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<ZdAssort> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<ZdAssort> query = Wrappers.lambdaQuery();
//        //时间范围，默认按createTime
//        if (searchDTO.getBeginTime() != null) {
//            query.ge(ZdAssort::getCreateTime, searchDTO.getBeginTime());
//        }
//        if (searchDTO.getEndTime() != null) {
//            Date endTime = searchDTO.getEndTime();
//            query.le(ZdAssort::getCreateTime, endTime);
//        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchDTO.getKeyword())) {
        //单个列用like
        //query. like(ZdAssort::getxxx, searchDTO.getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(ZdAssort::getxx1, searchDTO.getKeyword())
        // оr(). like(ZdAssort::getXX2, searchDTO.getKeyword()))
        //);
        //}
        query.eq(ZdAssort::getAssortSource, 3);
        query.eq(ZdAssort::getEffective, 1);

        //默认createTime倒序排序
        query.orderByDesc(ZdAssort::getAssortSort);
        List<ZdAssort> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<ZdAssort> query = Wrappers.lambdaQuery();
//        if (id != null) {
//            query.ne(ZdAssort::getId, id);
//        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(ZdAssort::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
